<?php
 class PageVO extends MotoObjectsHolderVO { public $id; public $parent; public $name; public $title; public $url; public $pageType; public $pageTypeId; public $linkable = true; public $removable = true; public $description = ''; public $keywords = ''; public $noIndex = false; public $noFollow = false; public $order; public $properties; public $height; public $isProtected; public $timestamp = 0; protected $_website = null; protected $_layout = null; public function __construct(DOMNode $parent = null) { parent::__construct($parent); $this->noFollow = self::getDefaultValue('PageVO.noFollow', $this->noFollow); $this->noIndex = self::getDefaultValue('PageVO.noIndex', $this->noIndex); if (!empty($parent)) { $this->loadDomElement($parent); } } public function loadDomElement(DOMNode $parent) { parent::loadDomElement($parent); $this->id = (integer) $parent->getAttribute('id'); $this->parent = (integer) $parent->getAttribute('parent'); $this->order = (integer) $parent->getAttribute('order'); $this->properties = PropertyVO::findAllByExpression( $parent, "./properties/item"); $node = MotoXML::findOneByXPath("./name", $parent); if (!is_null($node)) $this->name = (string) MotoUtil::trim($node->nodeValue); $node = MotoXML::findOneByXPath("./title", $parent); if (!is_null($node)) $this->title = (string) MotoUtil::trim($node->nodeValue); $node = MotoXML::findOneByXPath("./url", $parent); if (!is_null($node)) $this->url = (string) MotoUtil::trim($node->nodeValue); $node = MotoXML::findOneByXPath("./description", $parent); if (!is_null($node)) $this->description = (string) MotoUtil::trim($node->nodeValue); $node = MotoXML::findOneByXPath("./keywords", $parent); if (!is_null($node)) $this->keywords = (string) MotoUtil::trim($node->nodeValue); if ($parent->hasAttribute('linkable')) $this->linkable = (boolean) MotoUtil::toBoolean($parent->getAttribute('linkable')); if ($parent->hasAttribute('removable')) $this->removable = (boolean) MotoUtil::toBoolean($parent->getAttribute('removable')); if ($parent->hasAttribute('noIndex')) $this->noIndex = (boolean) MotoUtil::toBoolean($parent->getAttribute('noIndex')); if ($parent->hasAttribute('noFollow')) $this->noFollow = (boolean) MotoUtil::toBoolean($parent->getAttribute('noFollow')); if ($parent->hasAttribute('isProtected')) $this->isProtected = (boolean) MotoUtil::toBoolean($parent->getAttribute('isProtected')); $this->pageTypeId = (integer) $parent->getAttribute('pageType'); $loadPageType = !defined('IS_SMART_GETCONTENT'); $loadPageType = self::getDefaultOption('PageVO.loadType', $loadPageType); if ($loadPageType) { $this->pageType = PageTypeVO::findById($parent->getAttribute('pageType'), parent::$_structure); if (self::getDefaultOption('PageVO.jsEnabled', false)) { $this->layoutTypeId = $this->pageType->layoutType; } } $this->height = (integer) $parent->getAttribute('height'); $this->timestamp = time(); return $this; } function getWebsiteObjects() { if ($this->_website == null) { $node = MotoXML::findOneByXPath('./pages/page[@id=' . $this->pageTypeId . ']', parent::$_structure); if ($node != null) { $layoutType = $node->getAttribute('layoutType'); } $this->_website = new WebsiteVO( MotoXML::findOneByXPath('./website', MotoXML::create(CONTENT_RESOURSE_PATH) ) ); } return $this->_website; } function getLayoutObjects() { if ($this->_layout == null) { $layoutType = 0; if ($this->pageType != null) $layoutType = $this->pageType->layoutType; else { $node = MotoXML::findOneByXPath('./pages/page[@id=' . $this->pageTypeId . ']', parent::$_structure); if ($node != null) { $layoutType = $node->getAttribute('layoutType'); } } $this->_layout = LayoutVO::findById($layoutType, MotoXML::create(CONTENT_RESOURSE_PATH)); } return $this->_layout; } public function saveDomElement(DOMNode $parent) { parent::saveDomElement($parent); $parent->setAttribute('id', (integer) $this->id); $parent->setAttribute('parent', (integer) $this->parent); if (!is_null($this->order)) $parent->setAttribute('order', (integer) $this->order); if (!is_null($this->properties)) { $properties = $parent->appendChild(new DOMElement('properties')); foreach ($this->properties as $property) { $property->saveDomElement($properties->appendChild(new DOMElement('item'))); } } $parent->appendChild(new DOMElement('name')) ->appendChild($parent->ownerDocument->createCDATASection($this->name)); $parent->appendChild(new DOMElement('title')) ->appendChild($parent->ownerDocument->createCDATASection($this->title)); $parent->appendChild(new DOMElement('url')) ->appendChild($parent->ownerDocument->createCDATASection($this->url)); if (!empty($this->description)) $parent->appendChild(new DOMElement('description')) ->appendChild($parent->ownerDocument->createCDATASection($this->description)); if (!empty($this->keywords)) $parent->appendChild(new DOMElement('keywords')) ->appendChild($parent->ownerDocument->createCDATASection($this->keywords)); $parent->setAttribute('linkable',(string) MotoUtil::boolToString($this->linkable)); if ((string) MotoUtil::boolToString($this->removable) != 'true') $parent->setAttribute('removable',(string) MotoUtil::boolToString($this->removable)); if ((string) MotoUtil::boolToString($this->noIndex) != 'false') $parent->setAttribute('noIndex',(string) MotoUtil::boolToString($this->noIndex)); if ((string) MotoUtil::boolToString($this->noFollow) != 'false') $parent->setAttribute('noFollow',(string) MotoUtil::boolToString($this->noFollow)); if ((string) MotoUtil::boolToString($this->isProtected) != 'false') $parent->setAttribute('isProtected',(string) MotoUtil::boolToString($this->isProtected)); $parent->setAttribute('pageType', (string) isset($this->pageType) ? $this->pageType->id : null); $parent->setAttribute('height', (integer) $this->height); $parent->setAttribute('timestamp', (string) $this->timestamp); return $parent; } public function updateDomElement(DOMNode $parent) { $newNode = new DOMElement('page'); $oldNode = MotoXML::findOneByXPath(".//page[@id='{$this->id}']", $parent); if (!is_null($oldNode)) { $parent->replaceChild($newNode, $oldNode); } else { $parent->appendChild($newNode); } return $this->saveDomElement($newNode); } public static function findById($id, DOMNode $context) { return MotoXML::findOneByXPath(".//page[@id='{$id}']", $context, get_class()); } public static function findByUrl($url, DOMNode $context) { return MotoXML::findOneByXPath(".//page[url='{$url}']", $context, get_class()); } public static function findAll(DOMNode $context) { return MotoXML::findByXPath(".//page", $context, get_class()); } }